/*
 * Project: irond
 * Package: src.de.fhhannover.inform.ifmap.datastructure
 * File:    LinkContainer.java
 *
 * Copyright (C) 2010 Fachhochschule Hannover
 * Ricklinger Stadtweg 118, 30459 Hannover, Germany 
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an AS IS BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package de.fhhannover.inform.ifmap.datastructure;

import java.util.ArrayList;
/**
 * Container-Class for Links
 * @author Tobias
 *
 */
public class LinkContainer {
	private ArrayList<Link> links;

	public boolean isSingleValue() {
		for (Link l : links) {
			if (l.getAttribute("ifmap-cardinality").equals("singleValue")) {
				return true;
			}
		}
		return false;
	}

	public ArrayList<Link> getLinks() {
		return links;
	}

	public LinkContainer() {
		links = new ArrayList<Link>();
	}

	public String getUniqueLinkName() {
		if (links.size() > 0) {
			Link l = links.get(0);
			StringBuffer reader = new StringBuffer();
			reader.append(l.getName());
			reader.append(" [");
			reader.append(l.getIdentifier1().getName() + " "
					+ l.getIdentifier1().getAttributes().toString() + "] ");
			reader.append(l.getIdentifier2().getName() + " ["
					+ l.getIdentifier2().getAttributes().toString() + "]");
			return reader.toString();
		} else
			return "-";
	}

	public void addLink(Link link) {	
		Link tmp = null;
		for(Link l : links){
			if(link.equals(l)){
				tmp = l;
			}
		}
		if(tmp != null){
			if(link.getAttribute("ifmap-cardinality").equals("singleValue")){
				links.remove(tmp);					
		 }
		}
		links.add(link);
	}

	public int countLinks() {
		return links.size();
	}

	public String toString() {
		StringBuffer buf = new StringBuffer();
		for (Link l : links) {
			buf.append(l.toString() + "\r\n");
		}
		return buf.toString();
	}
}
