/*
 * Project: irond
 * Package: src.de.fhhannover.inform.ifmap.visual
 * File:    Subscription_GUI.java
 *
 * Copyright (C) 2010 Fachhochschule Hannover
 * Ricklinger Stadtweg 118, 30459 Hannover, Germany 
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an AS IS BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package de.fhhannover.inform.ifmap.visual;

import java.awt.BorderLayout;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JSplitPane;
import javax.swing.JComboBox;
import java.awt.FlowLayout;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JList;
import javax.swing.AbstractListModel;
import javax.swing.JRadioButton;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.awt.GridLayout;
import javax.swing.border.TitledBorder;
import javax.swing.SwingConstants;
import javax.swing.JLabel;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;
import javax.swing.JTextField;
import javax.swing.JButton;
import javax.swing.ButtonGroup;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.Dimension;

public class Subscription_GUI extends JFrame {

	public JPanel contentPane;
	private JTextField textField;
	private JTextField textField_1;
	private final ButtonGroup buttonGroup = new ButtonGroup();
	public AccessRequestPanel accessrequestpanel;
	public DevicePanel devicepanel;
	public IdentityPanel identitypanel;
	public IpAddressPanel ipaddresspanel;
	public MacAddressPanel macaddresspanel;	
	private JPanel attributesPanel;
	public  JRadioButton rdbtnIpaddress;
	public IpAddressPanel ipAddressPanel;
	public static SubscribeObservable so;
	public JRadioButton rdbtnMacaddress;
	public JRadioButton rdbtnAccessrequest;
	public JRadioButton rdbtnIdentity;
	public JRadioButton rdbtnDevice;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Subscription_GUI frame = new Subscription_GUI();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	public void setCallback(SubscribeObservable s){
		so = s;
	}
	/**
	 * Create the frame.
	 */
	public Subscription_GUI() {
		setResizable(false);
		setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		setBounds(100, 100, 789, 653);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		contentPane.setLayout(new BorderLayout(0, 0));
		setContentPane(contentPane);
		
		JSplitPane splitPane = new JSplitPane();
		splitPane.setEnabled(false);
		splitPane.setOrientation(JSplitPane.VERTICAL_SPLIT);
		contentPane.add(splitPane, BorderLayout.CENTER);
		
		JPanel identifierPanel = new JPanel();
		splitPane.setLeftComponent(identifierPanel);
		identifierPanel.setLayout(new BorderLayout(0, 0));
		
		JPanel panel_5 = new JPanel();
		FlowLayout flowLayout_1 = (FlowLayout) panel_5.getLayout();
		flowLayout_1.setAlignment(FlowLayout.LEFT);
		identifierPanel.add(panel_5, BorderLayout.NORTH);
		
		JPanel choosePanel = new JPanel();
		panel_5.add(choosePanel);
		choosePanel.setBorder(new TitledBorder(null, "Identifier type", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		choosePanel.setLayout(new GridLayout(0, 1, 0, 0));
		
		rdbtnIpaddress = new JRadioButton("ip-address");
		rdbtnIpaddress.setSelected(true);
		rdbtnIpaddress.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				if(ipaddresspanel == null){
					ipaddresspanel = new IpAddressPanel();
				}
				if(attributesPanel.getComponentCount() > 0)
					attributesPanel.remove(0);
				attributesPanel.add(ipaddresspanel);
				attributesPanel.revalidate();
			}
		});
		buttonGroup.add(rdbtnIpaddress);
		rdbtnIpaddress.setVerticalAlignment(SwingConstants.TOP);
		choosePanel.add(rdbtnIpaddress);
		
		rdbtnMacaddress = new JRadioButton("mac-address");
		rdbtnMacaddress.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				if(macaddresspanel == null){
					macaddresspanel = new MacAddressPanel();
				}
				if(attributesPanel.getComponentCount() > 0)
					attributesPanel.remove(0);
				attributesPanel.add(macaddresspanel);
				attributesPanel.revalidate();
			}
		});
		
		buttonGroup.add(rdbtnMacaddress);
		rdbtnMacaddress.setVerticalAlignment(SwingConstants.TOP);
		choosePanel.add(rdbtnMacaddress);
		
		rdbtnAccessrequest = new JRadioButton("access-request");
		rdbtnAccessrequest.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				if(accessrequestpanel == null){
					accessrequestpanel = new AccessRequestPanel();
				}
				if(attributesPanel.getComponentCount() > 0)
					attributesPanel.remove(0);
				attributesPanel.add(accessrequestpanel);
				attributesPanel.revalidate();
			}
		});
		buttonGroup.add(rdbtnAccessrequest);
		rdbtnAccessrequest.setVerticalAlignment(SwingConstants.TOP);
		choosePanel.add(rdbtnAccessrequest);
		
		rdbtnIdentity = new JRadioButton("identity");
		rdbtnIdentity.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				if(identitypanel == null){
					identitypanel = new IdentityPanel();
				}
				if(attributesPanel.getComponentCount() > 0)
					attributesPanel.remove(0);
				attributesPanel.add(identitypanel);
				attributesPanel.revalidate();
			}
		});
		buttonGroup.add(rdbtnIdentity);
		rdbtnIdentity.setVerticalAlignment(SwingConstants.TOP);
		choosePanel.add(rdbtnIdentity);
		
		rdbtnDevice = new JRadioButton("device");
		rdbtnDevice.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				if(devicepanel == null){
					devicepanel = new DevicePanel();
				}
				if(attributesPanel.getComponentCount() > 0)
					attributesPanel.remove(0);
				attributesPanel.add(devicepanel);
				attributesPanel.revalidate();
			}
		});
		buttonGroup.add(rdbtnDevice);
		choosePanel.add(rdbtnDevice);
		
		attributesPanel = new JPanel();
		panel_5.add(attributesPanel);
		FlowLayout fl_attributesPanel = (FlowLayout) attributesPanel.getLayout();
		fl_attributesPanel.setHgap(0);
		fl_attributesPanel.setVgap(0);
		
		ipAddressPanel = new IpAddressPanel();
		attributesPanel.add(ipAddressPanel);
		
		JPanel defaultPanel = new JPanel();
		identifierPanel.add(defaultPanel, BorderLayout.CENTER);
		defaultPanel.setLayout(new BorderLayout(0, 0));
		
		JPanel filterPanel = new JPanel();
		filterPanel.setBorder(new TitledBorder(null, "Default filter", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		defaultPanel.add(filterPanel, BorderLayout.CENTER);
		filterPanel.setLayout(new BorderLayout(0, 0));
		
		JPanel panel = new JPanel();
		filterPanel.add(panel, BorderLayout.WEST);
		panel.setLayout(new BorderLayout(0, 0));
		
		JPanel terminalPanel = new JPanel();
		panel.add(terminalPanel, BorderLayout.WEST);
		terminalPanel.setBorder(new TitledBorder(null, "terminal-identifier", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		terminalPanel.setLayout(new GridLayout(0, 1, 0, 0));
		
		JRadioButton radioButton = new JRadioButton("identity");
		radioButton.setVerticalAlignment(SwingConstants.TOP);
		terminalPanel.add(radioButton);
		
		JRadioButton radioButton_1 = new JRadioButton("access-request");
		radioButton_1.setVerticalAlignment(SwingConstants.TOP);
		terminalPanel.add(radioButton_1);
		
		JRadioButton radioButton_2 = new JRadioButton("mac-address");
		radioButton_2.setVerticalAlignment(SwingConstants.TOP);
		terminalPanel.add(radioButton_2);
		
		JRadioButton radioButton_3 = new JRadioButton("ip-address");
		radioButton_3.setVerticalAlignment(SwingConstants.TOP);
		terminalPanel.add(radioButton_3);
		
		JRadioButton radioButton_4 = new JRadioButton("device");
		terminalPanel.add(radioButton_4);
		
		JPanel panel_3 = new JPanel();
		panel.add(panel_3, BorderLayout.CENTER);
		panel_3.setLayout(new GridLayout(0, 1, 0, 0));
		
		JPanel panel_1 = new JPanel();
		panel_3.add(panel_1);
		panel_1.setLayout(new FlowLayout(FlowLayout.LEFT, 5, 5));
		
		JLabel lblMaxdepth = new JLabel("max-depth");
		panel_1.add(lblMaxdepth);
		lblMaxdepth.setHorizontalAlignment(SwingConstants.RIGHT);
		
		JSpinner spinner = new JSpinner();
		spinner.setPreferredSize(new Dimension(64, 22));
		panel_1.add(spinner);
		spinner.setModel(new SpinnerNumberModel(new Integer(10), null, null, new Integer(1)));
		
		JLabel lblMaxsize = new JLabel("max-size");
		panel_1.add(lblMaxsize);
		lblMaxsize.setHorizontalAlignment(SwingConstants.RIGHT);
		
		JSpinner spinner_1 = new JSpinner();
		spinner_1.setPreferredSize(new Dimension(64, 22));
		panel_1.add(spinner_1);
		spinner_1.setModel(new SpinnerNumberModel(new Integer(8192), null, null, new Integer(1)));
		
		JPanel panel_4 = new JPanel();
		FlowLayout flowLayout_3 = (FlowLayout) panel_4.getLayout();
		flowLayout_3.setAlignment(FlowLayout.LEFT);
		panel_3.add(panel_4);
		
		JLabel label = new JLabel("match-links");
		panel_4.add(label);
		
		textField_1 = new JTextField();
		panel_4.add(textField_1);
		textField_1.setColumns(40);
		
		JPanel panel_2 = new JPanel();
		panel_3.add(panel_2);
		
		JLabel lblMatchlinks = new JLabel("result-filter");
		lblMatchlinks.setHorizontalAlignment(SwingConstants.RIGHT);
		panel_2.add(lblMatchlinks);
		
		textField = new JTextField();
		panel_2.add(textField);
		textField.setColumns(40);
		
		JPanel okPanel = new JPanel();
		identifierPanel.add(okPanel, BorderLayout.SOUTH);
		FlowLayout flowLayout_4 = (FlowLayout) okPanel.getLayout();
		flowLayout_4.setAlignment(FlowLayout.RIGHT);
		
		JButton btnSubscribe = new JButton("Subscribe");
		btnSubscribe.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				if(so != null)
					so.update();
			}
		});
		okPanel.add(btnSubscribe);
		
		JPanel subscriptionPanel = new JPanel();
		FlowLayout flowLayout = (FlowLayout) subscriptionPanel.getLayout();
		flowLayout.setVgap(0);
		flowLayout.setHgap(0);
		splitPane.setRightComponent(subscriptionPanel);		
	}
}
